#ifndef _OPENGL_GAME_H
#define _OPENGL_GAME_H

#include "game-gui-glfw.hpp"

class OpenGLGame {
   public:
      OpenGLGame();
      ~OpenGLGame();

      void run(int width, int height, unsigned char guiFlags);

   private:
      GameGui* gui;
      GLFWwindow* window;

      bool initWindow(int width, int height, unsigned char guiFlags);
      void initOpenGL();
      void mainLoop();
      void cleanup();
};

void APIENTRY opengl_debug_callback(
   GLenum source,
   GLenum type,
   GLuint id,
   GLenum severity,
   GLsizei length,
   const GLchar* message,
   const void* userParam
);

#endif // _OPENGL_GAME_H